package eu.mhsl.craftattack.spawn.appliances.whitelist;

import eu.mhsl.craftattack.spawn.appliance.ApplianceListener;
import eu.mhsl.craftattack.spawn.util.text.DisconnectInfo;
import org.bukkit.event.EventHandler;
import org.bukkit.event.player.AsyncPlayerPreLoginEvent;
import org.bukkit.event.player.PlayerJoinEvent;

public class PlayerJoinListener extends ApplianceListener<Whitelist> {
    @EventHandler
    public void preLoginEvent(AsyncPlayerPreLoginEvent event) {
        try {
            this.getAppliance().integrityCheck(event.getUniqueId(), event.getName());
        } catch(DisconnectInfo.Throwable e) {
            event.disallow(
                AsyncPlayerPreLoginEvent.Result.KICK_WHITELIST,
                e.getDisconnectScreen().getComponent()
            );
        }
    }

    @EventHandler
    public void joinEvent(PlayerJoinEvent event) {
        try {
            this.getAppliance().lateIntegrityCheck(event.getPlayer());
        } catch(DisconnectInfo.Throwable e) {
            e.getDisconnectScreen().applyKick(event.getPlayer());
        }
    }
}
